/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2003  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@atlas.sk
*/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "config.h"
#include "fastgl.h"
#include "widgets.h"
#include "_fastgl.h"
#include "drivers.h"
//#include "fgttf.h"
//#include "fglmesa.h"

#ifdef _MSC_VER
#define	random rand
#define	srandom srand
#undef _WIN32
#endif

extern int rnd(int);
#ifndef _WIN32
#define rnd(a) (random()%(a+1))  // macro for randomize fnc
#else
#define rnd(a) (random(a))  // macro for randomize fnc
#endif
int a, b;
char s[80];

Window *w1, *w2;
ButtonGroup *grp;

int cas()
{
	static int a = 0, b;

	b = a;
	return ((a = clock()) - b);
}

int test3()
{
	int i, j, f, c,
		w=w1->GetWW(),
		h=w1->GetHW();

	f = clock();
	for (j = 0; j < 6000; j++)
	{
		w1->WindowFillEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowDrawEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowText(rnd(w1->GetW()), rnd(w1->GetH()), "Hello", rnd(255), rnd(255));
		w1->WindowBox(rnd(w1->GetW()), rnd(w1->GetH()), 40, 30,rnd(255));
//		cApp->Yield();
	}
	for (j = 0; j < h; j++)
	{
		for (i = 0; i < w; i++)
		{
			w1->WindowPixel(i, j, i + j);
		}
	}

  int polygon[10][2];
  for (j=0;j<100;j++)
  {
    int npoints = rand() % 7 + 3;
    for (i=0; i<npoints; i++) {
      polygon[i][0] = rand() % w;
      polygon[i][1] = rand() % h;
    }
//    FGPixel color = CreateColor(rand() % 256, rand() % 256, rand() % 256, 16);
    w1->WindowFillPolygon(npoints, polygon, rand());
  }
//	printf("cas pred printf=%d\n", clock());
	w1->set_colors(0, CWHITE);
	for (j = 0; j < 6000; j++)
	{
		c=rand()&127;
		if (c=='\n') c=12;
		w1->printf("%c", c);
	}
//	printf("cas po printf=%d\n", clock());

	for (j = 0; j < 600; j++)
	{
		w1->WindowLine(rnd(w1->GetWW()+100), rnd(w1->GetHW()), rnd(300), rnd(300), rnd(0xffffff));
	}
//	graph_change_mode(1024,768);
	return clock() - f;
}

void test(CallBack)
{
	Window *w = Window::GetCurrent();

	cas();
	a = test3();
	sprintf(s, "Graph WinMark - %d", a);
	w->WindowText(20, 180, s);
}


void filesel(char *,FileDialog *)
{
}

void ss(int)
{}

int main(int argc, char **argv)
{
	int aa=0, aaz, i;
	test_mmx();
	App MyApp(3,argc,argv,0,APP_ALL);
	Control *eb;
//	int ff = register_font((unsigned char*)_12x24, 12, 24, 256, 0);
//	set_font(ff);
	(void)new Window(&w1, 20, 20, X_width-40, Y_width-40, "Test Window", GuiHwnd(NULL), CBLACK, CGRAY1, WFRAMED|WMINIMIZE|WTITLED);
	(void)new Window(&w2, X_width-440, Y_width-340, 400, 300, "Main Window", 0, 0, CWHITED,
	WNOTEBOOK |
	WSIZEABLE | WMENU | WTITLED | WNOICON|WSTATUSBAR|WMINIMIZE|WFASTMOVE|WLASTFOCUS);
//new Window(0,100,100,4,4,"dfsaf");
	EditBox *ee = w2->AddEditBox(10,10,50,50,"gdfg",0,&aa);
//	new FGUpDown(ee, 2);
//	new FGUpDown(ee, 2);
//	w1->WindowSetWorkRect(4,23,2000,2000);

	App::GetRootWindow()->WindowPutBitmap(0, 0, 0,0,X_width, Y_width,w2);

	w2->AddBaseMenu("File ", 'F');
	w2->AddBaseMenu("Edit ", 'E');
	eb = w2->AddPushButton(320, 10, 60, 24, "Test", 'T', test);

//	set_font(ff);
	sprintf(s, " !@12 Resolution %dx%dx%d", X_width, Y_width, get_colordepth());
	w2->WindowText(20, 50, s);
	w2->WindowStatusBar(0, "asd");

	w1->WindowFillCircle(100,100,50,CBLACK+6);
	int mz[][2]={{62,186},{135,150},{221,197},{377,125},{231,25},{150,85},{10,18},{62,186}};
	w1->WindowFillPolygon(8,mz,CRED);
	w1->WindowDrawPolygon(8,mz,CRED);
	w1->WindowPatternLine(0, 0, 300, 0, &PatternDot);
	w1->WindowPatternLine(0, 20, 300, 20, &PatternSlashDot);
	w1->WindowPatternLine(0, 30, 300, 30, &PatternSlashDotSlash);
	w1->WindowPatternLine(0, 50, 300, 50, &PatternSlash);

			w1->set_fcolor(CBLUE);
			w1->set_ppop(_GTRANSP);
			w1->printf(20, 40, "  You can minimize this window! \n");
			w1->printf(0, 0, "and restore with right button again!\n");
			w1->set_ppop(_GSET);
/*
	FGPixel *bm = (FGPixel *)malloc(areasize(X_width,Y_width));
	FGmemset(bm, (FGPixel)0x0300, (X_width*Y_width));
	int rrr=clock();
	AlphaBlit(bm, bm, (X_width*Y_width), 120);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	printf("Blit = %d\n", clock()-rrr);
	free(bm);


	rrr=clock();
	set_ppop(0);
	for(int g=0;g<200;g++)
	{
		set_fcolor(g);
//		fill_box(0, 0, 800, 600);
	}
	for(int g=0;g<1000;g++)
	{
		set_fcolor(g);
		draw_line(0, 0, 800, g);
		draw_line(799, 0, 0, g);
	}
//	printf("Hw Blit = %d\n", clock()-rrr);
*/
	draw_line(0,0,800,600,CRED,0);
	w1->set_ppop(_GXOR);
	w1->WindowLine(-10,-10,3000,2000);
	w1->WindowFillCircle(400,160,60,CRED);
	w1->set_ppop(0);
	MyApp.SetTimerProc(0,10);
/*
	FGRect r;
	r.x = r.y = 0;
	r.w = r.h = 100;

	GLSurface aa(w2, &r);
	aa.MakeCurrent();
	aa.Draw();
	aa.Draw();
	aa.Draw();
*/
	w2->AddCheckButton(60, 48,"asd");
	w2->AddPointButton(60, 30,"asd");
	w2->AddTabPage("Prva");
	FGWidgetContainer cont;
	eb = w2->AddPushButton(20, 10, 60, 24, "Test", 'T', test);
	cont.AddToContainer(eb);
	eb = w2->AddSlideBarH(20, 40, -10, -20, 1, &aa);
//	eb->Disable();
	cont.AddToContainer(eb);
//	cont.DisableContainer();
//	aa = w2->ShowModal();
	w2->AddTabPage("Druhy");
	w2->AddTabPage("Tri00");
	w2->AddTabPage("Stvrty");
	w2->SetTabPage("Prva");
	EditBox *e = w1->AddEditBox(10,10,50,50,"gdfg",0,&aa);
	w1->AddEditBox(10,30,50,50,"gdfgfd",0,&aaz);
	delete new FGUpDown(e, 2);

	new FileDialog(filesel, 0, 0);

	w2->WindowShape(300,200,200,200);
/*
	unsigned short uu[10]={'d', 'o', 'm', 'a', ' ', 'j', 'e', 0};
	FontProperty f("verdana.ttf", 43);
	f.Bold(true);
	f.Underline(true);
	f.Shaded();
	w2->WindowTextUnicode(30,60,uu, &f, 0,CWHITE);
	f.Shaded();
	w2->WindowTextUnicode(30,90,uu, &f, 0,CWHITE);
*/
	w2->WindowFillTriangle(10,10,100,100,300,150);
//	w1->WindowBox(0,0,3000,520);
	TextEditor *ed = new TextEditor(&ed, "Untitled");
	text_out(0,0,"fdsafsdgsdgdsgdfgds",0,CWHITE,0,5);
	for(i=0;i<256;i++)
	{
		w1->WindowBox((i&15)*16, (i/16)*16, 16,16,FGCOLOR(i));
	}
	w1->AddLabel(260,0,"label", 'l');
	w1->WindowPanel(8, 8, 1504, 1584, " Vyska ");
	w1->set_ppop(0);
	w1->WindowLine(0,420, 600, 560, CBLUE);
	for(i=-100;i<2000;i++)
	{
		w1->WindowLine(i,i+200, i+200, i, CRED);
	}
	App::SetCaption("fdsfsaf");
	w1->WindowDrawCircle(100,100, 200, CRED);
	new FontDialog(ss, 3);
	MyApp.Run();
//	delete ed;
	delete w1;
	delete w2;
	return 0;
}

