CFLAGS  = -g2 -c -O2 -fno-exceptions -march=pentium
CC	= gcc
HDRS    = base.h _fastgl.h config.h

LIBS	= -ldl -lm -lstdc++
INCPATH	= -I/usr/X11R6/include -I/usr/include/freetype2 -I/usr/include/fastgl
LIBPATH	= -L/usr/X11R6/lib

OBJS	=   fastgl.o base.o resource.o widgets.o user.o dll.o editor.o bitmap.o timer.o drivers.o detect.o listbox.o
SRCS	=   fastgl.cpp base.cpp resource.cpp widgets.cpp user.cpp dll.cpp editor.cpp bitmap.cpp timer.cpp drivers.cpp detect.cpp listbox.cpp
BASE	=   /usr
INSTDIR =   $(BASE)/include/fastgl


ifdef X11SUPPORT
OPTIONS0	= -DX11_DRIVER
endif

ifdef DGASUPPORT
OPTIONS1	= -DDGA_DRIVER
endif

ifdef PNGSUPPORT
OPTIONS2	= -DFG_PNG
endif

ifdef JPGSUPPORT
OPTIONS3	= -DFG_JPEG
endif

ifdef TTFSUPPORT
OPTIONS4	= -DFG_TTF
OBJS2		= fgttf.o
LOBJS2		= fgttf.lo
SRCS2		= fgttf.cpp
endif

ifdef THREADSUPPORT
OPTIONS5	= -DFG_THREADED
endif

CFLAG	= $(CFLAGS) $(COLORDEPTH) $(OPTIONS0) $(OPTIONS1) $(OPTIONS2) $(OPTIONS3) $(OPTIONS4)  $(OPTIONS5) $(INCPATH)

default: $(STARGET)
	-rm -Rf /usr/local/include/fastgl
	-rm -f /usr/local/lib/$(DTARGET).4
	-rm -f /usr/local/lib/$(STARGET)
	install -d -g root -o root -m 755 $(INSTDIR)
	install -d -g root -o root -m 755 $(BASE)/lib
	install -d -g root -o root -m 755 $(BASE)/bin
	install -g root -o root -m 0644 fastgl.h $(INSTDIR)
	install -g root -o root -m 0644 base.h $(INSTDIR)
	install -g root -o root -m 0644 widgets.h $(INSTDIR)
	install -g root -o root -m 0644 internal.h $(INSTDIR)
	install -g root -o root -m 0644 listbox.h $(INSTDIR)
	install -g root -o root -m 0644 fglmesa.h $(INSTDIR)
	install -g root -o root -m 0644 $(STARGET) $(BASE)/lib
	install -g root -o root -m 0755 $(DTARGET).4 /usr/lib
	ldconfig

clean:
	rm -f *.a	
	rm -f *.o *.lo
	rm -f *.obj
	rm -f *.lib
	rm -f *.err
	rm -f *.so.?
	rm -f *.tds *.rc *.dsk *.desk core *.exe

$(STARGET): $(OBJS) $(OBJS2)
	ar rcs $(STARGET) $(OBJS) $(OBJS2) 

fastgl.o:  $(HDRS)     fastgl.cpp fastgl.h
	$(CC)  $(CFLAG)  fastgl.cpp 

bitmap.o:  $(HDRS)     bitmap.cpp fastgl.h
	$(CC)  $(CFLAG)  bitmap.cpp

widgets.o:  $(HDRS)     widgets.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG)  widgets.cpp

editor.o:  $(HDRS)     editor.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG)  editor.cpp

linux.o:  $(HDRS)     linux.cpp linux.h
	$(CC)  $(CFLAG)  linux.cpp

drivers.o:  $(HDRS)     drivers.cpp linux.h 
	$(CC)  $(CFLAG)  drivers.cpp

detect.o:  $(HDRS)     detect.cpp
	$(CC)  $(CFLAG)  detect.cpp

base.o:  $(HDRS)   base.cpp
	$(CC)  $(CFLAG)  base.cpp 

dll.o:  $(HDRS)   dll.cpp dll.h
	$(CC)  $(CFLAG)  dll.cpp 

user.o:  $(HDRS)   user.cpp fastgl.h
	$(CC)  $(CFLAG)  user.cpp

timer.o:  $(HDRS)   timer.cpp fastgl.h
	$(CC)  $(CFLAG)  timer.cpp

resource.o:  $(HDRS)   resource.cpp
	$(CC)  $(CFLAG)  resource.cpp

linkeyb.o:  linkeyb.h  linkeyb.cpp
	$(CC)  $(CFLAG)  linkeyb.cpp

fgstring.o:  fgstring.h fgstring.cpp
	$(CC)  $(CFLAG)  fgstring.cpp

listbox.o:  listbox.h  listbox.cpp
	$(CC)  $(CFLAG)  listbox.cpp

fgttf.o:  fgttf.h  fgttf.cpp
	$(CC)  $(CFLAG)  fgttf.cpp

fastgl.lo:  $(HDRS)     fastgl.cpp fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    fastgl.cpp

bitmap.lo:  $(HDRS)     bitmap.cpp fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    bitmap.cpp

widgets.lo:  $(HDRS)     widgets.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    widgets.cpp

editor.lo:  $(HDRS)     editor.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    editor.cpp

linux.lo:  $(HDRS)     linux.cpp linux.h
	$(CC)  $(CFLAG) -fPIC -o $@    linux.cpp

drivers.lo:  $(HDRS)     drivers.cpp linux.h 
	$(CC)  $(CFLAG) -fPIC -o $@    drivers.cpp

detect.lo:  $(HDRS)     detect.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    detect.cpp

base.lo:  $(HDRS)   base.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    base.cpp 

dll.lo:  $(HDRS)   dll.cpp dll.h
	$(CC)  $(CFLAG) -fPIC -o $@    dll.cpp 

user.lo:  $(HDRS)   user.cpp fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    user.cpp

timer.lo:  $(HDRS)   timer.cpp fastgl.h
	$(CC)  $(CFLAG) -fPIC -o $@    timer.cpp

resource.lo:  $(HDRS)   resource.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    resource.cpp

linkeyb.lo:  linkeyb.h  linkeyb.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    linkeyb.cpp

fgstring.lo:  fgstring.h fgstring.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    fgstring.cpp

listbox.lo:  listbox.h  listbox.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    listbox.cpp

fgttf.lo:  fgttf.h  fgttf.cpp
	$(CC)  $(CFLAG) -fPIC -o $@    fgttf.cpp

