#undef NONAMELESSUNION

#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>

#ifdef _WIN32
#include <windows.h>
#endif

#ifndef FASTGL_BPP
#ifdef BPP8
#define FASTGL_BPP		8
#endif

#ifdef BPP15
#define FASTGL_BPP		15
#endif

#ifdef BPP16
#define FASTGL_BPP		16
#endif

#ifdef BPP32
#define FASTGL_BPP		32
#endif
#endif // FASTGL_BPP

// as default
#ifndef FASTGL_BPP
#define FASTGL_BPP	8
#define BPP8
#endif

#if defined(__BORLANDC__) && defined(_WIN32)
#include <alloc.h>
#include <_str.h>
#elif defined(_MSC_VER)
#else
#include <unistd.h>
#endif

#ifndef TRUE
#define	TRUE   1
#define	FALSE  0
#endif

#ifndef	M_PI
#define	M_PI	3.1415926
#endif

#ifdef __QNX__
#include <signal.h>
#include <process.h>
#include <unistd.h>
#undef Yield
#endif // qnx

#if defined(__sun__)
#include <pthread.h>
#define PTHREAD_MUTEX_NORMAL	PTHREAD_MUTEX_FAST_NP
#define PTHREAD_MUTEX_RECURSIVE	PTHREAD_MUTEX_RECURSIVE_NP
#endif

#if defined(__linux__)
#include <linux/version.h>
#include <pthread.h>
#define PTHREAD_MUTEX_NORMAL	PTHREAD_MUTEX_TIMED_NP
#define PTHREAD_MUTEX_RECURSIVE	PTHREAD_MUTEX_RECURSIVE_NP
#ifdef __BORLANDC__
#pragma link "libpthread.so"
#endif
#endif // linux

#ifdef __DJGPP__
#include <dpmi.h>
#endif // djgpp

// force link
#ifdef __BORLANDC__
#ifndef INTO_FGL
#ifndef __linux__
#if (FASTGL_BPP == 8)
	#pragma link "fgl.lib"
#elif (FASTGL_BPP == 15 || FASTGL_BPP == 16)
	#pragma link "fgl16.lib"
#elif (FASTGL_BPP == 32)
	#pragma link "fgl32.lib"
#endif

#else	// LINUX libs

#if (FASTGL_BPP == 8)
	#pragma link "fgl.a"
#elif (FASTGL_BPP == 15 || FASTGL_BPP == 16)
	#pragma link "fgl16.a"
#elif (FASTGL_BPP == 32)
	#pragma link "fgl32.a"
#endif
#endif // INTO_FGL
#endif // __linux__

#ifdef __linux__
#ifdef X11_DRIVER
#pragma link "libX11.so"
#pragma link "libXext.so"
#ifdef DGA_DRIVER
#pragma link "libXxf86dga.a"
#endif
#endif

#endif // __linux__
#endif // __borlandc__

#ifdef __WATCOMC__
#include <i86.h>
#ifndef __SW_3S
#error "you must use stack call conventions! (-3s)"
#endif
// this line force linker to linking with fgl.lib implicitly
#if (FASTGL_BPP == 8)
	#pragma library (fgl)
#elif (FASTGL_BPP == 15 || FASTGL_BPP == 16)
	#pragma library (fgl16)
#elif (FASTGL_BPP == 32)
	#pragma library (fgl32)
#endif
#endif  // watcom

// for WATCOM & DOS
#ifdef __DOS__
#define __MSDOS__
#endif // dos

#if (FASTGL_BPP==8)
#define	INDEX_COLORS
#elif (FASTGL_BPP==15)
#define	DIRECT_COLORS	15
#define FGDirectColor(rgb) (((rgb&0xF80000)>>9) | ((rgb&0xF800)>>6) | ((rgb&0xF8)>>3))
#define ExpandColor(rgb) (((rgb<<9)&0xF80000) | ((rgb<<6)&0xF800) | ((rgb<<3)&0xF8))
#define kRedComponent(pix) ((pix>>7)&0xf8)
#define kGreenComponent(pix) ((pix>>2)&0xf8)
#define kBlueComponent(pix) ((pix<<3)&0xf8)
#elif (FASTGL_BPP==16)
#define	DIRECT_COLORS	16
#define FGDirectColor(rgb) (((rgb&0xF80000)>>8) | ((rgb&0xFc00)>>5) | ((rgb&0xF8)>>3))
#define ExpandColor(rgb) (((rgb<<8)&0xF80000) | ((rgb<<5)&0xFc00) | ((rgb<<3)&0xF8))
#define kRedComponent(pix) ((pix>>8)&0xf8)
#define kGreenComponent(pix) ((pix>>3)&0xfc)
#define kBlueComponent(pix) ((pix<<3)&0xf8)
#elif (FASTGL_BPP==32)
#define	TRUE_COLORS
#define FGDirectColor
#define ExpandColor
#define kRedComponent(pix) ((pix>>16)&0xff)
#define kGreenComponent(pix) ((pix>>8)&0xff)
#define kBlueComponent(pix) (pix&0xff)
#endif // fastgl_bpp

#ifdef __MSDOS__
#define PRTRSC	396 // ALT_F12
#define	BACKSP	0x08
#define	KLEFT	0x24b
#define	KUP		0x248
#define	KDOWN	0x250
#define	KRIGHT	0x24d

#define	INSERT	0x252
#define	DEL		0x253
#define	HOME	0x247
#define	END		0x24f
#define	PGUP	0x249
#define	PGDOWN	0x251

#define ALT_A	286
#define ALT_B	304
#define ALT_C	302
#define ALT_D	288
#define ALT_E	274
#define ALT_F	289
#define ALT_G	290
#define ALT_H	291
#define ALT_I	279
#define ALT_J	292
#define ALT_K	293
#define ALT_L	294
#define ALT_M	306
#define ALT_N	305
#define ALT_O	280
#define ALT_P	281
#define ALT_Q	272
#define ALT_R	275
#define ALT_S	287
#define ALT_T	276
#define ALT_U	278
#define ALT_V	303
#define ALT_W	273
#define ALT_X	301
#define ALT_Y	277
#define	ALT_Z	300

#define	F01		315
#define	F02		316
#define	F03		317
#define	F04		318
#define	F05		319
#define	F06		320
#define	F07		321
#define	F08		322
#define	F09		323
#define	F10		324
#define	F11		389
#define	F12		390

#define	ALT_F01		360
#define	ALT_F02		(ALT_F01+1)
#define	ALT_F03		(ALT_F01+2)
#define	ALT_F04		(ALT_F01+3)
#define	ALT_F05		(ALT_F01+4)
#define	ALT_F06		(ALT_F01+5)
#define	ALT_F07		(ALT_F01+6)
#define	ALT_F08		(ALT_F01+7)
#define	ALT_F09		(ALT_F01+8)
#define	ALT_F10		(ALT_F01+9)
#define	ALT_F11		395
#define	ALT_F12		396

#define	CTRL_F01		350
#define	CTRL_F02		(CTRL_F01+1)
#define	CTRL_F03		(CTRL_F01+2)
#define	CTRL_F04		(CTRL_F01+3)
#define	CTRL_F05		(CTRL_F01+4)
#define	CTRL_F06		(CTRL_F01+5)
#define	CTRL_F07		(CTRL_F01+6)
#define	CTRL_F08		(CTRL_F01+7)
#define	CTRL_F09		(CTRL_F01+8)
#define	CTRL_F10		(CTRL_F01+9)
#define	CTRL_F11		393
#define	CTRL_F12		394

#define	ALT_UP		408
#define	ALT_DOWN	416
#define	ALT_RIGHT 	413
#define	ALT_LEFT	411

#define	ALT_TAB			421
#define	ALT_INSERT		418
#define	ALT_DEL			419
#define	ALT_HOME		407
#define	ALT_END			415
#define ALT_PGUP		409
#define ALT_PGDOWN		417

#define	CTRL_UP		(KUP+0x100)
#define	CTRL_DOWN	(KDOWN+0x100)
#define	CTRL_RIGHT 	(KRIGHT+0x100)
#define	CTRL_LEFT	(KLEFT+0x100)

#define	CTRL_TAB	0x194
#define	CTRL_INSERT		658
#define	CTRL_DEL		659
#define	CTRL_HOME		631
#define	CTRL_END		629
#define CTRL_PGUP	644
#define CTRL_PGDOWN	630
#endif

#ifdef _WIN32
#define PRTRSC	0x21b
#define	BACKSP	0x8
#define	KUP		0x126
#define	KDOWN	0x128
#define	KRIGHT	0x127
#define	KLEFT	0x125

#define	INSERT	0x12d
#define	DEL		0x12e
#define	HOME	0x124
#define	END		0x123
#define	PGUP	0x121
#define	PGDOWN	0x122

#define ALT_A	0x1061
#define ALT_B	(ALT_A+1)
#define ALT_C	(ALT_A+2)
#define ALT_D	(ALT_A+3)
#define ALT_E	(ALT_A+4)
#define ALT_F	(ALT_A+5)
#define ALT_G	(ALT_A+6)
#define ALT_H	(ALT_A+7)
#define ALT_I	(ALT_A+8)
#define ALT_J	(ALT_A+9)
#define ALT_K	(ALT_A+10)
#define ALT_L	(ALT_A+11)
#define ALT_M	(ALT_A+12)
#define ALT_N	(ALT_A+13)
#define ALT_O	(ALT_A+14)
#define ALT_P	(ALT_A+15)
#define ALT_Q	(ALT_A+16)
#define ALT_R	(ALT_A+17)
#define ALT_S	(ALT_A+18)
#define ALT_T	(ALT_A+19)
#define ALT_U	(ALT_A+20)
#define ALT_V	(ALT_A+21)
#define ALT_W	(ALT_A+22)
#define ALT_X	(ALT_A+23)
#define ALT_Y	(ALT_A+24)
#define	ALT_Z	(ALT_A+25)

#define	F01		0x270
#define	F02		(F01+1)
#define	F03		(F01+2)
#define	F04		(F01+3)
#define	F05		(F01+4)
#define	F06		(F01+5)
#define	F07		(F01+6)
#define	F08		(F01+7)
#define	F09		(F01+8)
#define	F10		(F01+9)
#define	F11		(F01+10)
#define	F12		(F01+11)

#define	ALT_F01		0x1201
#define	ALT_F02		0x1202
#define	ALT_F03		0x1203
#define	ALT_F04		0x1204
#define	ALT_F05		0x1205
#define	ALT_F06		0x1206
#define	ALT_F07		0x1207
#define	ALT_F08		0x1208
#define	ALT_F09		0x1209
#define	ALT_F10		0x120a
#define	ALT_F11		0x120b
#define	ALT_F12		0x120c

#define	CTRL_F01		0x401
#define	CTRL_F02		0x402
#define	CTRL_F03		0x403
#define	CTRL_F04		0x404
#define	CTRL_F05		0x405
#define	CTRL_F06		0x406
#define	CTRL_F07		0x407
#define	CTRL_F08		0x408
#define	CTRL_F09		0x409
#define	CTRL_F10		0x40a
#define	CTRL_F11		0x40b
#define	CTRL_F12		0x40c

#define	ALT_UP		(KUP+0x1000)
#define	ALT_DOWN	(KDOWN+0x1000)
#define	ALT_RIGHT 	(KRIGHT+0x1000)
#define	ALT_LEFT	(KLEFT+0x1000)

#define	ALT_TAB			4105
#define	ALT_INSERT		4642
#define	ALT_DEL			4223
#define	ALT_HOME		4664
#define	ALT_END			4665
#define ALT_PGUP		4662
#define ALT_PGDOWN		4663

#define	CTRL_UP		(KUP+0x100)
#define	CTRL_DOWN	(KDOWN+0x100)
#define	CTRL_RIGHT 	(KRIGHT+0x100)
#define	CTRL_LEFT	(KLEFT+0x100)

#define	CTRL_TAB		0xFFF
#define	CTRL_INSERT		802
#define	CTRL_DEL		0x7F
#define	CTRL_HOME		824
#define	CTRL_END		825
#define CTRL_PGUP	(PGUP+0x100)
#define CTRL_PGDOWN	(PGDOWN+0x100)
#endif

#if defined( __linux__ ) || defined( __rtems__ ) || defined(__sun__)
#define PRTRSC	0x20e
#define	BACKSP		0x8
#define	KUP		0x232
#define	KDOWN	0x233
#define	KRIGHT	0x235
#define	KLEFT	0x234

#define	INSERT	0x222
#define	DEL		0x7F
#define	HOME		0x238
#define	END		0x239
#define	PGUP	0x236
#define	PGDOWN	0x237

#define ALT_A	0x1061
#define ALT_B	(ALT_A+1)
#define ALT_C	(ALT_A+2)
#define ALT_D	(ALT_A+3)
#define ALT_E	(ALT_A+4)
#define ALT_F	(ALT_A+5)
#define ALT_G	(ALT_A+6)
#define ALT_H	(ALT_A+7)
#define ALT_I	(ALT_A+8)
#define ALT_J	(ALT_A+9)
#define ALT_K	(ALT_A+10)
#define ALT_L	(ALT_A+11)
#define ALT_M	(ALT_A+12)
#define ALT_N	(ALT_A+13)
#define ALT_O	(ALT_A+14)
#define ALT_P	(ALT_A+15)
#define ALT_Q	(ALT_A+16)
#define ALT_R	(ALT_A+17)
#define ALT_S	(ALT_A+18)
#define ALT_T	(ALT_A+19)
#define ALT_U	(ALT_A+20)
#define ALT_V	(ALT_A+21)
#define ALT_W	(ALT_A+22)
#define ALT_X	(ALT_A+23)
#define ALT_Y	(ALT_A+24)
#define	ALT_Z	(ALT_A+25)

#define	F01		0x301
#define	F02		(F01+1)
#define	F03		(F01+2)
#define	F04		(F01+3)
#define	F05		(F01+4)
#define	F06		(F01+5)
#define	F07		(F01+6)
#define	F08		(F01+7)
#define	F09		(F01+8)
#define	F10		(F01+9)
#define	F11		(F01+10)
#define	F12		(F01+11)

#define	ALT_F01		0x1201
#define	ALT_F02		0x1202
#define	ALT_F03		0x1203
#define	ALT_F04		0x1204
#define	ALT_F05		0x1205
#define	ALT_F06		0x1206
#define	ALT_F07		0x1207
#define	ALT_F08		0x1208
#define	ALT_F09		0x1209
#define	ALT_F10		0x120a
#define	ALT_F11		0x120b
#define	ALT_F12		0x120c

#define	CTRL_F01		0x401
#define	CTRL_F02		0x402
#define	CTRL_F03		0x403
#define	CTRL_F04		0x404
#define	CTRL_F05		0x405
#define	CTRL_F06		0x406
#define	CTRL_F07		0x407
#define	CTRL_F08		0x408
#define	CTRL_F09		0x409
#define	CTRL_F10		0x40a
#define	CTRL_F11		0x40b
#define	CTRL_F12		0x40c

#define	ALT_UP		(KUP+0x1000)
#define	ALT_DOWN	(KDOWN+0x1000)
#define	ALT_RIGHT 	(KRIGHT+0x1000)
#define	ALT_LEFT	(KLEFT+0x1000)

#define	ALT_TAB			4105
#define	ALT_INSERT		4642
#define	ALT_DEL			4223
#define	ALT_HOME		4664
#define	ALT_END			4665
#define ALT_PGUP		4662
#define ALT_PGDOWN		4663

#define	CTRL_UP		(KUP+0x100)
#define	CTRL_DOWN	(KDOWN+0x100)
#define	CTRL_RIGHT 	(KRIGHT+0x100)
#define	CTRL_LEFT	(KLEFT+0x100)

#define	CTRL_TAB		0xFFF
#define	CTRL_INSERT		802
#define	CTRL_DEL		0x7F
#define	CTRL_HOME		824
#define	CTRL_END		825
#define CTRL_PGUP	(PGUP+0x100)
#define CTRL_PGDOWN	(PGDOWN+0x100)
#endif //linux

#ifdef __QNX__
#define PRTRSC	429 
#define	BACKSP	0x7f
#define	KUP		417
#define	KDOWN	425
#define	KRIGHT	422
#define	KLEFT	420

#define	INSERT	427
#define	DEL		428
#define	HOME	416
#define	END		424
#define	PGUP	418
#define	PGDOWN	426

#define ALT_A	481
#define ALT_B	(ALT_A+1)
#define ALT_C	(ALT_A+2)
#define ALT_D	(ALT_A+3)
#define ALT_E	(ALT_A+4)
#define ALT_F	(ALT_A+5)
#define ALT_G	(ALT_A+6)
#define ALT_H	(ALT_A+7)
#define ALT_I	(ALT_A+8)
#define ALT_J	(ALT_A+9)
#define ALT_K	(ALT_A+10)
#define ALT_L	(ALT_A+11)
#define ALT_M	(ALT_A+12)
#define ALT_N	(ALT_A+13)
#define ALT_O	(ALT_A+14)
#define ALT_P	(ALT_A+15)
#define ALT_Q	(ALT_A+16)
#define ALT_R	(ALT_A+17)
#define ALT_S	(ALT_A+18)
#define ALT_T	(ALT_A+19)
#define ALT_U	(ALT_A+20)
#define ALT_V	(ALT_A+21)
#define ALT_W	(ALT_A+22)
#define ALT_X	(ALT_A+23)
#define ALT_Y	(ALT_A+24)
#define	ALT_Z	(ALT_A+25)

#define	F01		385
#define	F02		386
#define	F03		387
#define	F04		388
#define	F05		389
#define	F06		390
#define	F07		391
#define	F08		392
#define	F09		393
#define	F10		394
#define	F11		430
#define	F12		431

#define	ALT_F01		465
#define	ALT_F02		(ALT_F01+1)
#define	ALT_F03		(ALT_F01+2)
#define	ALT_F04		(ALT_F01+3)
#define	ALT_F05		(ALT_F01+4)
#define	ALT_F06		(ALT_F01+5)
#define	ALT_F07		(ALT_F01+6)
#define	ALT_F08		(ALT_F01+7)
#define	ALT_F09		(ALT_F01+8)
#define	ALT_F10		(ALT_F01+9)
#define	ALT_F11		462
#define	ALT_F12		463

#define	CTRL_F01		405
#define	CTRL_F02		(CTRL_F01+1)
#define	CTRL_F03		(CTRL_F01+2)
#define	CTRL_F04		(CTRL_F01+3)
#define	CTRL_F05		(CTRL_F01+4)
#define	CTRL_F06		(CTRL_F01+5)
#define	CTRL_F07		(CTRL_F01+6)
#define	CTRL_F08		(CTRL_F01+7)
#define	CTRL_F09		(CTRL_F01+8)
#define	CTRL_F10		(CTRL_F01+9)
#define	CTRL_F11		446
#define	CTRL_F12		447

#define	ALT_UP	449
#define	ALT_DOWN	457
#define	ALT_RIGHT 454
#define	ALT_LEFT	 452

//#define   ALT_TAB     // not defined
#define	ALT_INSERT		459
#define	ALT_DEL			460
#define	ALT_HOME		448
#define	ALT_END			456
#define ALT_PGUP		450
#define ALT_PGDOWN		458

#define	CTRL_UP		433
#define	CTRL_DOWN	441
#define	CTRL_RIGHT 	438
#define	CTRL_LEFT	436

#define	CTRL_TAB		415
#define	CTRL_INSERT		443
#define	CTRL_DEL		444
#define	CTRL_HOME		432
#define	CTRL_END		440
#define CTRL_PGUP		434
#define CTRL_PGDOWN		442
#endif // QNX

#define CTRL_A	1
#define CTRL_B	2
#define CTRL_C	3
#define CTRL_D	4
#define CTRL_E	5
#define CTRL_F	6
#define CTRL_G	7
#define CTRL_H	8
#define CTRL_I	9
#define CTRL_J	10
#define CTRL_K	11
#define CTRL_L	12
#define CTRL_M	13
#define CTRL_N	14
#define CTRL_O	15
#define CTRL_P	16
#define CTRL_Q	17
#define CTRL_R	18
#define CTRL_S	19
#define CTRL_T	20
#define CTRL_U	21
#define CTRL_V	22
#define CTRL_W	23
#define CTRL_X	24
#define CTRL_Y	25
#define	CTRL_Z	26

#if (((__GNUC__<<16) + (__GNUC_MINOR__ <<8) + (__GNUC_PATCHLEVEL)) >= 0x030201)
#define HIDDEN __attribute__ ((weak))
#else
#define HIDDEN
#endif

