/*
	OpenGUI - Drawing & Windowing library

	Copyright (C) 1996,2003  Marian Krivos

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Library General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Library General Public License for more details.

	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	nezmar@atlas.sk
*/

#include <fastgl/fastgl.h>
#include <fastgl/widgets.h>

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{
	App *MyApp = new App(3,argc,argv,CWHITED,APP_ALL);
	Window *wnd = new Window(&wnd, GetXRes()-440, GetYRes()-340, 400, 220, "Main Window", 0, CBLUELIGHT, CWHITE,
		WSIZEABLE | WTITLED | WMINIMIZE|WFRAMED);

	unsigned short uu[16] = {'h', 'e', 'l', 'l', 'o', ' ', 'w','o','r','l','d','!', 0};

	FontProperty *arial23 = new FontProperty("arir____.ttf", 23);
	FontProperty *helvetica23 = new FontProperty("helr____.ttf", 23);

	wnd->WindowTextUnicode(30,30,uu, arial23, 0,CWHITE);
	wnd->WindowTextUnicode(30,60,uu, helvetica23, 0,CWHITE);

	arial23->Shaded();
	wnd->WindowTextUnicode(30,120,uu, arial23, CBLUELIGHT,CWHITE);
	helvetica23->Shaded();
	wnd->WindowTextUnicode(30,150,uu, helvetica23, CBLUELIGHT,CWHITE);

	FontProperty *arial12 = new FontProperty("arir____.ttf", 12);
	FontProperty *helvetica12 = new FontProperty("helr____.ttf", 12);

	arial12->Solid();
	wnd->WindowTextUnicode(230,90,uu, arial12, CRED,CWHITE);
	wnd->WindowTextUnicode(230,30,uu, helvetica12, CRED,CWHITE);

	arial12->Shaded();
	wnd->WindowTextUnicode(230,120,uu, arial12, CBLUELIGHT,CWHITE);
	helvetica12->Shaded();
	wnd->WindowTextUnicode(230,150,uu, helvetica12, CBLUELIGHT,CWHITE);

	MyApp->Run();

	delete wnd;
	delete arial23;
	delete helvetica23;
	delete arial12;
	delete helvetica12;
	delete MyApp;
	
	return 0;
}

 