CFLAGS  = -g -c -O2 -fno-exceptions -DX11_DRIVER
CC	= gcc
HDRS    = base.h _fastgl.h config.h

LIBS	= -ldl -lm -lstdc++
INCPATH	= -I/usr/X/include
LIBPATH	= -L/usr/X/lib

OBJS	=   fastgl.o base.o resource.o widgets.o user.o dll.o solaris.o editor.o bitmap.o timer.o drivers.o detect.o listbox.o
BASE	=   /usr/local
INSTDIR =   $(BASE)/include/fastgl


ifdef X11SUPPORT
OPTIONS0	= -DX11_DRIVER
endif

ifdef DGASUPPORT
OPTIONS1	= -DDGA_DRIVER
endif

ifdef PNGSUPPORT
OPTIONS2	= -DFG_PNG
endif

ifdef JPGSUPPORT
OPTIONS3	= -DFG_JPEG
endif

CFLAG	= $(CFLAGS) $(COLORDEPTH) $(OPTIONS0) $(OPTIONS1) $(OPTIONS2) $(OPTIONS3) $(INCPATH)

default: $(STARGET) #file2asm # $(DTARGET).3 
	-rm -Rf /usr/include/fastgl
	-rm -Rf /usr/local/include/fastgl
	-rm -f /usr/local/lib/$(DTARGET).3
	-rm -f /usr/local/lib/$(STARGET)
	-rm -f /usr/lib/$(DTARGET).3
	-rm -f /usr/lib/$(STARGET)
	-mkdir $(BASE)
	-mkdir $(BASE)/include
	-mkdir $(BASE)/lib
	-mkdir $(BASE)/bin
	-mkdir $(INSTDIR)
	cp -f fastgl.h $(INSTDIR)
	cp -f base.h $(INSTDIR)
	cp -f widgets.h $(INSTDIR)
	cp -f listbox.h $(INSTDIR)
	cp -f fglmesa.h $(INSTDIR)
	cp -f $(STARGET) $(BASE)/lib

clean:
	rm -f *.a	
	rm -f *.o
	rm -f *.obj
	rm -f *.lib
	rm -f *.err
	rm -f *.so.?
	rm -f file2asm core *.exe

$(STARGET): $(OBJS)
	ar rcs $(STARGET) $(OBJS) 

$(DTARGET).3: $(OBJS)
	$(CC) -g -fnostdinc -shared -Wl,-soname,$(DTARGET) -o $(DTARGET).3 $(OBJS) $(LIBS) $(LIBPATH) $(X11SUPPORT) $(DGASUPPORT) $(JPGSUPPORT) $(PNGSUPPORT)

file2asm: file2asm.cpp
	$(CC) -s -O -o file2asm file2asm.cpp
	cp file2asm $(BASE)/bin/file2asm
		
fastgl.o:  $(HDRS)     fastgl.cpp fastgl.h
	$(CC)  $(CFLAG)  fastgl.cpp 

bitmap.o:  $(HDRS)     bitmap.cpp fastgl.h
	$(CC)  $(CFLAG)  bitmap.cpp

widgets.o:  $(HDRS)     widgets.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG)  widgets.cpp

editor.o:  $(HDRS)     editor.cpp widgets.h fastgl.h
	$(CC)  $(CFLAG)  editor.cpp

solaris.o:  $(HDRS)     solaris.cpp solaris.h
	$(CC)  $(CFLAG)  solaris.cpp

drivers.o:  $(HDRS)     drivers.cpp linux.h 
	$(CC)  $(CFLAG)  drivers.cpp

detect.o:  $(HDRS)     detect.cpp
	$(CC)  $(CFLAG)  detect.cpp

base.o:  $(HDRS)   base.cpp
	$(CC)  $(CFLAG)  base.cpp 

dll.o:  $(HDRS)   dll.cpp dll.h
	$(CC)  $(CFLAG)  dll.cpp 

user.o:  $(HDRS)   user.cpp fastgl.h
	$(CC)  $(CFLAG)  user.cpp

timer.o:  $(HDRS)   timer.cpp fastgl.h
	$(CC)  $(CFLAG)  timer.cpp

resource.o:  $(HDRS)   resource.cpp
	$(CC)  $(CFLAG)  resource.cpp

fgstring.o:  fgstring.h fgstring.cpp
	$(CC)  $(CFLAG)  fgstring.cpp

listbox.o:  listbox.h  listbox.cpp
	$(CC)  $(CFLAG)  listbox.cpp

engine.o:engine.asm
	nasm -f elf -dLINUX engine.asm

